//---------------------------------------------------------------------------

#include <vcl.h>
#include <windows.h>
#pragma hdrstop
#include "DiseqcU.h"
#include "Fiche1.h"
#include "Settings.h"

HINSTANCE ProgDVDInstance;      // Handle to calling program (ProgDVB)
HWND      ProgDVDWindow;        // HWND of calling window
TProgAPISignalState state;
TProgAPIDiSEqCmd cmdDiseqc;
unsigned short int lgsat3600;   // longitude sat en diximes de degrs
String lgsat; // longitude sat sous la forme xxx.x E ou xxx.x W

extern bool autodrive;
extern bool usals;
extern double Lat;     // latitude du lieu en degrs, + si Nord, - si Sud
extern double Lg;      // longitude du lieu en degrs, + si Ouest, - si Est

extern void affich_niveau_reception(void);
extern void exploredir(String path, String filespec,TListBox *Liste);

//---------------------------------------------------------------------------

#pragma argsused
BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD fwdreason, LPVOID lpvReserved)
{
        return 1;
}
//---------------------------------------------------------------------------

void On_Start(HINSTANCE MDInstance, HWND MDWnd, BOOL Log_Set, int DLL_ID, char *My_Hot_Key, char *Api_Version, int *Keep_me_running)
{ String chaine;
  String nomsat;
  String nomfich;

  ProgDVDInstance=MDInstance;
  ProgDVDWindow  =MDWnd;

  Form1=new TForm1(NULL);
  Form2=new TForm2(NULL);

  if (FileExists("\DiseqcU.ini"))
    { Form1->ListeSat->Items->LoadFromFile("\DiseqcU.ini");
      Form2->ListeSat->Items->LoadFromFile("\DiseqcU.ini");
    }
   else
    { ShowMessage("Fichier DiseqcU.ini non trouv !");
      return;
    }
  if (Form1->ListeSat->Items->Strings[1].SubString(1,13)=="Autodrive=YES")
    { autodrive=true;
      Form2->CBAutoDrive->Checked=true;
     }
   else
    { autodrive=false;
      Form2->CBAutoDrive->Checked=false;
    }

   if (Form1->ListeSat->Items->Strings[2].SubString(1,9)=="USALS=YES")
     { usals=true;
       Form2->CBusals->Checked=true;
     }
    else
     { usals=false;
       Form2->CBusals->Checked=false;
     }
   if (Form1->ListeSat->Items->Strings[3].SubString(1,9)=="Latitude=")
         { chaine=Form1->ListeSat->Items->Strings[3].Delete(1,9);
           if (chaine.SubString(chaine.Length(),1)=="N")
            Form2->Nord->Checked=true;
           if (chaine.SubString(chaine.Length(),1)=="S")
            Form2->Sud->Checked=true;
           Form2->Latitude->Text=chaine.SubString(1,chaine.Pos(" ")-1);
           Lat=Form2->Latitude->Text.ToDouble();
           if (Form2->Sud->Checked==true) Lat=-Lat;
         }
   if (Form1->ListeSat->Items->Strings[4].SubString(1,10)=="Longitude=")
         { chaine=Form1->ListeSat->Items->Strings[4].Delete(1,10);
           if (chaine.SubString(chaine.Length(),1)=="W")
            Form2->LgOuest->Checked=true;
           if (chaine.SubString(chaine.Length(),1)=="E")
            Form2->LgEst->Checked=true;
           Form2->Longitude->Text=chaine.SubString(1,chaine.Pos(" ")-1);
           Lg=Form2->Longitude->Text.ToDouble();
           if (Form2->LgEst->Checked==true) Lg=-Lg;
         }

  exploredir("\Transponders","????.ini",Form2->ListBox1);
  //LisBox1 contient la liste des fichiers ini du rpertoire Transponders
  int n=Form2->ListBox1->Items->Count;
  for (int i=0; i<n;i++)
    { nomfich=Form2->ListBox1->Items->Strings[i];
      Form2->ListBox2->Items->Clear();
      Form2->ListBox2->Items->LoadFromFile("\Transponders\\"+nomfich);
      if (Form2->ListBox2->Items->Strings[0]=="[SATTYPE]")
         lgsat3600=Form2->ListBox2->Items->Strings[1].SubString(3,4).ToInt();
        else continue;
      if (lgsat3600<1800) lgsat=IntToStr(lgsat3600) + " E";
        else  lgsat=IntToStr(3600-lgsat3600) + " W";
      lgsat=lgsat.Insert(".",lgsat.Length()-2);          // xxxx => xxx.x
      while (lgsat.Length()<7) lgsat.Insert(" ",1);
      nomsat=Form2->ListBox2->Items->Strings[2];
      nomsat.Delete(1,2);       // suppress 2=
      Form2->ComboBox1->Items->Add(lgsat+" "+nomsat);
    }
  Form2->ComboBox1->ItemIndex=0;

  *Keep_me_running=0; // Keep running
  //MultiDecLog = Log_Set;
  //ProgDVD_DLL_ID=DLL_ID;
  *My_Hot_Key='G';   // or 0x00 means No HotKey
  //ShowMessage("DiseqcU started !");
}
//---------------------------------------------------------------------------

void On_Exit(HINSTANCE MDInstance, HWND MDWnd, BOOL Log_Set)
{
   Form1->ListeSat->Items->SaveToFile("\diseqcU.ini");
}
//---------------------------------------------------------------------------

void On_Menu_Select(unsigned int MenuID )
{   switch(MenuID)
    { case 40703 :                      // Set up Diseqc 1.2
        Form2->ShowModal();
        break;
      case 40705 :                      // Commandes moteur
        Form1->Show();
        break;
      case 40709:                       // About DiseqcU
         ShowMessage("Diseqc 1.2 plugin by parabolus\n\n"
                     "avec support USALS\n\n"
                     "Test sous Windows XP avec carte Hauppauge Nexus\n\n"
                     "moteurs STAB HH100 et MOTECK SG2100\n\n"
                     "et diffrentes versions de ProgDVB => 4.40");
        break;
     }
}
//---------------------------------------------------------------------------

int PROG_Get_Signal_Level( void )
{  state.dwSize=sizeof(state);
   SendMessage(ProgDVDWindow,WM_USER,PROGAPI_GET_SIGNAL_LEVEL,DWORD(&state));
   return  state.dwLevel;
}
//---------------------------------------------------------------------------

int PROG_Get_Signal_Quality( void )
{  state.dwSize=sizeof(state);
   SendMessage(ProgDVDWindow,WM_USER,PROGAPI_GET_SIGNAL_LEVEL,DWORD(&state));
   return  state.dwQuality;
}

//---------------------------------------------------------------------------

int PROG_Send_Diseqc( void)
{  cmdDiseqc.dwSize=sizeof(cmdDiseqc);
   return SendMessage(ProgDVDWindow,WM_USER,PROGAPI_SEND_DISEQC,DWORD(&cmdDiseqc));
}
//---------------------------------------------------------------------------

void On_Channel_Change( struct TProgramm82 CurrentProgramm )
{  String lignesat,s;
   char numerosat;
   int iboucle;

   unsigned char octetfaible=CurrentProgramm.Extern_Buffer[0];
   unsigned char octetfort=CurrentProgramm.Extern_Buffer[1];
   lgsat3600=octetfort*256+octetfaible;
   if (lgsat3600<1800) lgsat=IntToStr(lgsat3600) + " E";
    else  lgsat=IntToStr(3600-lgsat3600) + " W";
   lgsat=lgsat.Insert(".",lgsat.Length()-2);          // xxxx => xxx.x
   for(iboucle=5;iboucle<Form1->ListeSat->Items->Count;iboucle++) //by-pass 5 lignes titre
     { s = Form1->ListeSat->Items->Strings[iboucle].SubString(4,7);
       s=s.TrimLeft();                  // suppression espaces en tte
       if (lgsat==s)                    // if sat longitude found in table
         { Form1->ListeSat->ItemIndex=iboucle;
           if (autodrive)
             { if (usals)
                 Form1->GoToAPClick(Form1);     // goto angular position
                else
                 Form1->GoToSatClick(Form1);    // goto sat position number
             }
           break;
         }
     }
   if (iboucle==Form1->ListeSat->Items->Count)
    ShowMessage("longitude satellite "+IntToStr(lgsat3600)+" inconnue dans diseqc.ini !");
   affich_niveau_reception();
}
//---------------------------------------------------------------------------


