//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Fiche1.h"
#include "DiseqcU.h"
#include "Settings.h"
#include "trigo.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "GradProcessBar"
#pragma resource "*.dfm"

TForm1 *Form1;
String lignesat;
char numerosat;
int level, quality;
double LgSat;   // longitude du satellite en degrs
double angularposition(double Lat, double Lg, double LgSat);
double angle_rot;
int FractCoding[10]={0x00,0x02,0x03,0x05,0x06,0x08,0x0A,0x0B,0x0D,0x0E};

extern TProgAPISignalState state;
extern TProgAPIDiSEqCmd cmdDiseqc;
extern TProgAPIGetChannelName  getChannelName;
extern struct TTransponder TPtp;
extern unsigned short int lgsat3600;   // longitude sat en diximes de degrs
extern double Lat; // latitude du lieu en degrs, + si Nord, - si Sud
extern double Lg;  // longitude du lieu en degrs, + si Ouest, - si Est

void  Reset(void);
char  HexaToChar(char hex_digit); // Conversion digit hexa => sa valeur binaire
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
  DecimalSeparator='.';
}
//---------------------------------------------------------------------------

void affich_niveau_reception(void)
{  level=PROG_Get_Signal_Level();
   Form1->NiveauRecep->Position=level;
   quality=PROG_Get_Signal_Quality();
   Form1->QualiteRecep->Position=quality;
}
//---------------------------------------------------------------------------

// Conversion d'un digit hexa en sa valeur binaire
char  HexaToChar(char hex_digit)
{  char table[16] ={ '\x00','\x01','\x02','\x03','\x04','\x05','\x06','\x07',
                    '\x08','\x09','\x0A','\x0B','\x0C','\x0D','\x0E','\x0F' };

   if( hex_digit>='0' && hex_digit<='9' ) return table[hex_digit-'0'];
   if( hex_digit>='A' && hex_digit<='F' ) return table[hex_digit-'A'+10];
   return table[0];
}
//---------------------------------------------------------------------------

void Reset(void)
{  strcpy(cmdDiseqc.Cmd,"\xE0\x31\x00\x00");
   cmdDiseqc.dwCmdLength='\x03';
   PROG_Send_Diseqc();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::EnvoiCommandeClick(TObject *Sender)
{  int i;
   char hexahaut,hexabas;
   for (i=1;i<=5;i++)
     {  if (!isxdigit(*Commande->Text.SubString((i-1)*3+1,1).c_str())) break;
        hexahaut=*Commande->Text.SubString((i-1)*3+1,1).c_str();
        hexabas =*Commande->Text.SubString((i-1)*3+2,1).c_str();
        cmdDiseqc.Cmd[i-1]=(char)(HexaToChar(hexahaut)*16+HexaToChar(hexabas));
     }
    cmdDiseqc.dwCmdLength= i-1;
    PROG_Send_Diseqc();
    affich_niveau_reception();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SecondWestClick(TObject *Sender)
{  if (Lat>0)  strcpy(cmdDiseqc.Cmd,"\xE0\x31\x69\x00");
     else      strcpy(cmdDiseqc.Cmd,"\xE0\x31\x68\x00");
   cmdDiseqc.Cmd[3]=(char)Duree->Value;
   cmdDiseqc.dwCmdLength='\x04';
   PROG_Send_Diseqc();
   affich_niveau_reception();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SecondEastClick(TObject *Sender)
{  if (Lat>0)  strcpy(cmdDiseqc.Cmd,"\xE0\x31\x68\x00");
     else      strcpy(cmdDiseqc.Cmd,"\xE0\x31\x69\x00");
   cmdDiseqc.Cmd[3]=(char)Duree->Value;
   cmdDiseqc.dwCmdLength='\x04';
   PROG_Send_Diseqc();
   affich_niveau_reception();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::StepWestClick(TObject *Sender)
{  if (Lat>0) strcpy(cmdDiseqc.Cmd,"\xE0\x31\x69\x00");
     else     strcpy(cmdDiseqc.Cmd,"\xE0\x31\x68\x00");
   cmdDiseqc.Cmd[3]=(char)-Step->Value;  // 1 byte sign moins
   cmdDiseqc.dwCmdLength='\x04';
   PROG_Send_Diseqc();
   affich_niveau_reception();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::StepEastClick(TObject *Sender)
{  if (Lat>0)  strcpy(cmdDiseqc.Cmd,"\xE0\x31\x68\x00");
     else      strcpy(cmdDiseqc.Cmd,"\xE0\x31\x69\x00");
   cmdDiseqc.Cmd[3]=(char)-Step->Value;   // 1 byte sign moins
   cmdDiseqc.dwCmdLength='\x04';
   PROG_Send_Diseqc();
   affich_niveau_reception();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::BoutonOuestMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{  if (Lat>0) strcpy(cmdDiseqc.Cmd,"\xE0\x31\x69\x00");
     else     strcpy(cmdDiseqc.Cmd,"\xE0\x31\x68\x00");
   cmdDiseqc.dwCmdLength='\x04';
   PROG_Send_Diseqc();
   affich_niveau_reception();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::BoutonOuestMouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{  BoutonStopClick(Sender);
   affich_niveau_reception();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::BoutonEstMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{ if (Lat>0)  strcpy(cmdDiseqc.Cmd,"\xE0\x31\x68\x00");
    else      strcpy(cmdDiseqc.Cmd,"\xE0\x31\x69\x00");
  cmdDiseqc.dwCmdLength='\x04';
  PROG_Send_Diseqc();
  affich_niveau_reception();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::BoutonEstMouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{ BoutonStopClick(Sender);
  affich_niveau_reception();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::BoutonStopClick(TObject *Sender)
{ strcpy(cmdDiseqc.Cmd,"\xE0\x31\x60");
  cmdDiseqc.dwCmdLength='\x03';
  PROG_Send_Diseqc();
  affich_niveau_reception();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButeeOuestClick(TObject *Sender)
{  if (Lat>0)  strcpy(cmdDiseqc.Cmd,"\xE0\x31\x67\x00");
     else      strcpy(cmdDiseqc.Cmd,"\xE0\x31\x66\x00");
   cmdDiseqc.dwCmdLength='\x03';
   PROG_Send_Diseqc();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButeeEstClick(TObject *Sender)
{  if (Lat>0)  strcpy(cmdDiseqc.Cmd,"\xE0\x31\x66\x00");
     else      strcpy(cmdDiseqc.Cmd,"\xE0\x31\x67\x00");
   cmdDiseqc.dwCmdLength='\x03';
   PROG_Send_Diseqc();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::DeactButeeClick(TObject *Sender)
{  strcpy(cmdDiseqc.Cmd,"\xE0\x31\x63\x00");
   cmdDiseqc.dwCmdLength='\x03';
   PROG_Send_Diseqc();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::GoToSatClick(TObject *Sender)
{  lignesat= ListeSat->Items->Strings[ListeSat->ItemIndex];
   numerosat=(char)lignesat.SubString(1,2).ToInt();
   strcpy(cmdDiseqc.Cmd,"\xE0\x31\x6B\x00");
   cmdDiseqc.Cmd[3]=numerosat;
   cmdDiseqc.dwCmdLength='\x04';
   PROG_Send_Diseqc();
   affich_niveau_reception();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::StoreSatClick(TObject *Sender)
{  lignesat= ListeSat->Items->Strings[ListeSat->ItemIndex];
   numerosat=(char)lignesat.SubString(1,2).ToInt();
   strcpy(cmdDiseqc.Cmd,"\xE0\x31\x6A\x00");
   cmdDiseqc.Cmd[3]=numerosat;
   cmdDiseqc.dwCmdLength='\x04';
   PROG_Send_Diseqc();
   affich_niveau_reception();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormDeactivate(TObject *Sender)
{
   Form1->Close();
}
//---------------------------------------------------------------------------

double angularposition(double Lat, double Lg, double LgSat)
{ double beta;
  double azimut, elevation;
  const double r=6378.16;           // rayon de la terre en km
  const double H=35786.43;          // altitude du satellite

  //azimut=RadToDeg*atan2(tan_deg(LgSat-Lg),sin_deg(Lat))+180.;
  //beta=acos(cos_deg(LgSat-Lg)*cos_deg(Lat));      //   beta en radians
  //elevation=RadToDeg*atan2(cos(beta)-(r/(r+H)),sin(beta));
  /*
  return (RadToDeg*atan2(-cos_deg(elevation)*sin_deg(azimut),
                         sin_deg(elevation)*cos_deg(Lat)
                            -cos_deg(elevation)*sin_deg(Lat)*cos_deg(azimut)));
  */
  return (RadToDeg*atan2( (r+H)*sin_deg(LgSat-Lg),
                          (r+H)*cos_deg(LgSat-Lg)-r*cos_deg(Lat) ));
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ListeSatClick(TObject *Sender)
{  //Lat=Form2->Latitude->Text.ToDouble();
   //Lg=Form2->Longitude->Text.ToDouble();
   lignesat= ListeSat->Items->Strings[ListeSat->ItemIndex];
   LgSat=lignesat.SubString(4,5).TrimLeft().ToDouble();
   if (lignesat.SubString(10,1)=="E") LgSat=-LgSat;
   angle_rot=angularposition(Lat,Lg,LgSat);
   AngularPos->Text=fabs(angle_rot);
   if (angle_rot < 0)
     Direction->Text="To East";
    else
     Direction->Text="To West";
}

//---------------------------------------------------------------------------

void __fastcall TForm1::GoToAPClick(TObject *Sender)
{  double degres;
   int angle_cmd, diziemes;

   ListeSatClick(Sender);
   diziemes=floor(modf(fabs(angle_rot),&degres)*10.0);
   angle_cmd=degres*0x10+FractCoding[diziemes];
   if (angle_rot<0)
     { if (Lat>0) angle_cmd |= 0xE000;      // vers l'Est
        else      angle_cmd |= 0xD000;      // les commandes sont inverses
     }                                      // dans l'hmisphre Sud
    else
     { if (Lat>0) angle_cmd |= 0xD000;      // vers l'Ouest
        else      angle_cmd |= 0xE000;      // inversed if South hemisphere
     }
   strcpy(cmdDiseqc.Cmd,"\xE0\x31\x6E");
   cmdDiseqc.Cmd[3]=(angle_cmd & 0xFF00) / 0x100;
   cmdDiseqc.Cmd[4]= angle_cmd & 0xFF;
   cmdDiseqc.dwCmdLength='\x05';
   PROG_Send_Diseqc();
   affich_niveau_reception();
}
//---------------------------------------------------------------------------

