//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Settings.h"
#include "Fiche1.h"
#include <math.h>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

TForm2 *Form2;
String VirguleEnPoint(String s);
bool autodrive=false;
bool usals=false;
double Lat;     // latitude du lieu en degrs, + si Nord, - si Sud
double Lg;      // longitude du lieu en degrs, + si Ouest, - si Est


//---------------------------------------------------------------------------
__fastcall TForm2::TForm2(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------


void __fastcall TForm2::CreateParams(TCreateParams& Params)
{ //Griser le bouton fermeture et interdire le <Alt F4>
  TForm::CreateParams(Params);
  Params.WindowClass.style |= CS_NOCLOSE;
}
//---------------------------------------------------------------------------

void __fastcall TForm2::BoutonCloseClick(TObject *Sender)
{
   Form2->Close();
}
//---------------------------------------------------------------------------

void __fastcall TForm2::FormClose(TObject *Sender, TCloseAction &Action)
{
   LatitudeExit(Sender);
   LongitudeExit(Sender);
}
//---------------------------------------------------------------------------


void __fastcall TForm2::CBusalsClick(TObject *Sender)
{   Form2->Latitude->Enabled=Form2->CBusals->Checked;
    Form2->Longitude->Enabled=Form2->CBusals->Checked;
    if (CBusals->Checked)
     { usals=true;
       Form2->ListeSat->Items->Strings[2]="USALS=YES";
     }
    else
     { usals=false;
       Form2->ListeSat->Items->Strings[2]="USALS=NO ";
     }
}
//---------------------------------------------------------------------------

void __fastcall TForm2::LatitudeExit(TObject *Sender)
{ if (Latitude->Modified==true)
    { try
        { Lat=VirguleEnPoint(Latitude->Text).ToDouble();
          if (Lat>90.)
            { ShowMessage("la latitude doit tre comprise entre 0 et 90");
              Latitude ->SetFocus();
            }
           else
             if (Sud->Checked==true) Lat=-Lat;
        }
      catch(...)
        { ShowMessage("latitude incorrecte");
          Latitude->SetFocus();
        }
    }
  if (Lat>0)
     Form2->ListeSat->Items->Strings[3]="Latitude="+String(fabs(Lat))+" N";
    else
     Form2->ListeSat->Items->Strings[3]="Latitude="+String(fabs(Lat))+" S";
  Form2->Repaint();
}
//---------------------------------------------------------------------------

void __fastcall TForm2::LongitudeExit(TObject *Sender)
{ if (Longitude->Modified==true)
   { try
       { Lg=VirguleEnPoint(Longitude->Text).ToDouble();
         if (Lg>180.)
           { ShowMessage("la longitude doit tre comprise entre 0 et 180");
             Longitude->SetFocus();
           }
          else
            if (LgEst->Checked==true) Lg=-Lg;
       }
       catch(...)
         { ShowMessage("longitude incorrecte");
           Longitude->SetFocus();
         }
   }
  if (Lg>0.)
     Form2->ListeSat->Items->Strings[4]="Longitude="+String(fabs(Lg))+" W";
    else
     Form2->ListeSat->Items->Strings[4]="Longitude="+String(fabs(Lg))+" E";
   Form2->Repaint();
}
//---------------------------------------------------------------------------

void __fastcall TForm2::NordClick(TObject *Sender)
{  Latitude->Modified=true;
   LatitudeExit(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TForm2::SudClick(TObject *Sender)
{ Latitude->Modified=true;
  LatitudeExit(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TForm2::LgOuestClick(TObject *Sender)
{ Longitude->Modified=true;
  LongitudeExit(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TForm2::LgEstClick(TObject *Sender)
{ Longitude->Modified=true;
  LongitudeExit(Sender);
}
//---------------------------------------------------------------------------

String VirguleEnPoint(String s)
// renvoie une chaine copie de la chaine passe en paramtre
// dans laquelle la virgule a t remplace par un point
{ String chaine=s;
  int VirgulePos=s.Pos(",");
  if (VirgulePos!=0)
    { chaine.Delete(VirgulePos,1);
      chaine.Insert('.',VirgulePos);
    }
  return chaine;
}
//---------------------------------------------------------------------------

void __fastcall TForm2::FormDeactivate(TObject *Sender)
{ Form2->ListeSat->Items->SaveToFile("\DiseqcU.ini");
  Form1->ListeSat->Items->LoadFromFile("\DiseqcU.ini");
}
//---------------------------------------------------------------------------

void __fastcall TForm2::CBAutoDriveClick(TObject *Sender)
{  if (CBAutoDrive->Checked)
    { autodrive=true;
      Form2->ListeSat->Items->Strings[1]="Autodrive=YES";
    }
   else
    { autodrive=false;
      Form2->ListeSat->Items->Strings[1]="Autodrive=NO ";
    }
   Form2->Repaint();
}
//---------------------------------------------------------------------------

void __fastcall TForm2::DeleteClick(TObject *Sender)
{
  if (Form2->ListeSat->ItemIndex>4)
    Form2->ListeSat->Items->Delete(Form2->ListeSat->ItemIndex);
}
//---------------------------------------------------------------------------

void __fastcall TForm2::SetClick(TObject *Sender)
{  String lignesat, ligneini;
   int spacepos;
   double LgSat;

   lignesat= Form2->ComboBox1->Items->Strings[Form2->ComboBox1->ItemIndex];
   ligneini=SatPos->Text+" "+lignesat;
   if (SatPos->Text.ToInt()<10) ligneini.Insert(" ",1);
   if (ListeSat->ItemIndex>5)
     ListeSat->Items->Insert(ListeSat->ItemIndex,ligneini);
    else
     ListeSat->Items->Insert(5,ligneini);
}
//---------------------------------------------------------------------------

