//---------------------------------------------------------------------------
#include <vcl\vcl.h>
//#pragma hdrstop

#include "trigo.h"
#include "math.h"

//---------------------------------------------------------------------------
double sin_deg(double degres)	// sinus d'un angle exprim en degrs
{ return sin(degres*DegToRad);
}

//---------------------------------------------------------------------------
double cos_deg(double degres)	// cosinus d'un angle exprim en degrs
{ return cos(degres*DegToRad);
}

//---------------------------------------------------------------------------
double tan_deg(double degres)	// tangente d'un angle exprim en degrs
{ return tan(degres*DegToRad);
}

//---------------------------------------------------------------------------
double reduc360(double angle)
// rduction d'un angle en degrs (positif, nul ou ngatif)
// en un angle entre 0 et 360 degrs
{ if (angle!=0)
    return (angle - 360. * floor(angle/360.));
  else return angle;
}

//---------------------------------------------------------------------------
String DegEnHeuresMin(double degres)
{ // conversion d'une variable exprime en degrs
  // en une variable chane exprime en heures et minutes
  String chaine, chaineminutes;
  double heures, minutes, fraction, entier;
  heures=degres/15.;		// le mme instant exprim en heures
  heures+=.5/60.;			// ajout d'une demi minute pour l'arrondi
  fraction=modf(heures,&entier);
  chaine=FloatToStr(entier)+"h ";
  minutes=floor(fraction*60.);
  chaineminutes=FloatToStr(minutes);
  if (minutes<10.0) chaineminutes="0"+chaineminutes;
  chaine+=chaineminutes;
  return chaine;
}

//---------------------------------------------------------------------------
String DegEnHeuresMinSec(double degres)
{ // conversion d'une variable exprime en degrs
  // en une variable chane exprime en heures, minutes et secondes
  String chaine, chaineminutes, chainesecondes;
  double heures, minutes, secondes, fraction, entier;
  heures=degres/15.;		// le mme instant exprim en heures
  heures+=.5/3600.;			// ajout d'une demi seconde pour l'arrondi

  fraction=modf(heures,&entier);
  chaine=FloatToStr(entier)+"h ";

  minutes=fraction*60.;
  fraction=modf(minutes,&entier);
  chaineminutes=FloatToStr(entier)+" ";
  if (minutes<10.0) chaineminutes="0"+chaineminutes;
  chaine+=chaineminutes;

  secondes=floor(fraction*60);
  chainesecondes=FloatToStr(secondes);
  if (secondes<10.0) chainesecondes="0"+chainesecondes;
  chaine+=chainesecondes;

  return chaine;
}
//---------------------------------------------------------------------------
String EditDegMinDizieme(double degres)
// dition d'un angle en degrs, minutes et dizimes de minute d'arc
{ double minutes, fraction, entier;
  String chaine, chaineminutes;

  if (degres<0.) chaine="-"; else chaine="";
  degres=fabs(degres)+.05/60.;   	// arrondi au dizime de minute d'arc
  fraction=modf(degres,&entier);
  chaine+=FloatToStr(entier)+" ";
  minutes=fraction*60.;
  chaineminutes=FloatToStr(minutes);
  if (minutes<10.0) chaineminutes="0"+chaineminutes;
  chaine+=chaineminutes.SubString(1,4)+"' ";
  return chaine;
}
//---------------------------------------------------------------------------
String EditDegMinSec(double degres)
{ double minutes, secondes, fraction, entier;
  String chaine;
  fraction=modf(degres,&entier);
  chaine=FloatToStr(entier)+" ";
  minutes=fraction*60.;
  fraction=modf(minutes,&entier);
  chaine+=FloatToStr(entier)+"' ";
  secondes=fraction*60.;
  chaine+=FloatToStr(secondes).SubString(1,2)+"\"";
  return chaine;
}
//---------------------------------------------------------------------------
int sign(double x)
{ if (x>=0.) return 1;
   else return -1;
}
//---------------------------------------------------------------------------



